abstract class Statement {
}

class CompoundStatement extends Statement {
    public Statement stm1;
    public Statement stm2;
    public CompoundStatement (Statement stm1, Statement stm2) {
        this.stm1 = stm1;
        this.stm2 = stm2;
    }
}

class AssignStatement extends Statement {
    public String id;
    public Expression exp;
    public AssignStatement (String id, Expression exp) {
        this.id = id;
        this.exp = exp;
    }
}

class PrintStatement extends Statement {
    public List<Expression> exps;
    public PrintStatement (List<Expression> exps) {
        this.exps = exps;
    }
}

abstract class Expression {
}

class IdExpression extends Expression {
    public String id;
    public IdExpression (String id) {
        this.id = id;
    }
}

class NumExpression extends Expression {
    public int num;
    public NumExpression (int num) {
        this.num = num;
    }
}

class OpExpression extends Expression {
    public Expression left;
    public int op;
    public Expression right;
    public OpExpression (Expression left, int op, Expression right) {
        this.left = left;
        this.op = op;
        this.right = right;
    }
}

class EsepExpression extends Expression {
    public List<Statement> stm;
    public Expression exp;
    public EsepExpression (List<Statement> stm, Expression exp) {
        this.stm = stm;
        this.exp = exp;
    }
}

abstract class ExpressionList {
}

class PairExpressionList extends ExpressionList {
    public Expression head;
    public ExpressionList tail;
    public PairExpressionList (Expression head, ExpressionList tail) {
        this.head = head;
        this.tail = tail;
    }
}

class LastExpressionList extends ExpressionList {
    public Expression head;
    public LastExpressionList (Expression head) {
        this.head = head;
    }
}

